## apache2 2.4.38

=== debian/changelog ===
apache2 (2.4.38-3+deb10u8) buster; urgency=medium

  * Non-maintainer upload.
  * CVE-2022-22719: denial of service in mod_lua via crafted request body.
  * CVE-2022-22720: HTTP request smuggling.
  * CVE-2022-22721: integer overflow leading to buffer overflow write.
  * CVE-2022-23943: heap memory overwrite via crafted data in mod_sed.
  * CVE-2022-26377: mod_proxy_ajp: Possible request smuggling.
  * CVE-2022-28614: read beyond bounds via ap_rwrite().
  * CVE-2022-28615: Read beyond bounds in ap_strcmp_match().
  * CVE-2022-29404: Denial of service in mod_lua r:parsebody.
  * CVE-2022-30522: mod_sed denial of service.
  * CVE-2022-30556: Information Disclosure in mod_lua with websockets.
  * CVE-2022-31813: mod_proxy X-Forwarded-For dropped by hop-by-hop mechanism.

 -- Roberto C. Sánchez <roberto@debian.org>  Mon, 20 Jun 2022 15:03:00 -0400

apache2 (2.4.38-3+deb10u7) buster-security; urgency=medium

  * Fix possible NULL dereference or SSRF in forward proxy configurations
    (CVE-2021-44224)
  * lua: improve error handling (Closes: CVE-2021-44790)
  * mod_proxy_uwsgi: Remove duplicate slashes at the beginning of PATH_INFO
    (relaxes the behaviour introduced by the CVE-2021-36160 fix)

 -- Yadd <yadd@debian.org>  Tue, 21 Dec 2021 17:50:43 +0100

apache2 (2.4.38-3+deb10u6) buster-security; urgency=high

  [ Yadd, Moritz Muehlenhoff ]
  * Initialize the request fields on read failure to avoid NULLs
    (Closes: CVE-2021-34798)
  * mod_proxy_uwsgi: Fix PATH_INFO setting for generic worker
    (Closes: CVE-2021-36160)
  * Fix ap_escape_quotes with pre-escaped quotes (Closes: CVE-2021-39275)
  * Sanity checks on the configured UDS path (Closes: CVE-2021-40438)

 -- Yadd <yadd@debian.org>  Thu, 30 Sep 2021 05:50:49 +0200

apache2 (2.4.38-3+deb10u5) buster-security; urgency=medium

  * Fix "NULL pointer dereference on specially crafted HTTP/2 request"
    (Closes: #989562, CVE-2021-31618)
  * Fix various low security issues (Closes: CVE-2020-35452, CVE-2021-26690,
    CVE-2021-26691, CVE-2021-30641) and fix related test

 -- Yadd <yadd@debian.org>  Thu, 10 Jun 2021 12:13:06 +0200

apache2 (2.4.38-3+deb10u4) buster-security; urgency=high

  * Import http2 modules from 2.4.46 (Closes: CVE-2020-9490, CVE-2020-11993)
  * Fix error out on HTTP header larger than 16K (Closes: CVE-2020-11984)
  * Fix bad regexp in mod_rewrite (Closes: CVE-2020-1927)
  * Fix uninitialized memory when proxying to a malicious FTP server
    (Closes: CVE-2020-1934)

 -- Xavier Guimard <yadd@debian.org>  Tue, 25 Aug 2020 22:08:29 +0200

apache2 (2.4.38-3+deb10u3) buster-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Annoatate patch for CVE-2019-10092: Add missing APLOGNO's in
    modules/proxy/mod_proxy.c and modules/proxy/mod_proxy_ftp.c

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 15 Oct 2019 21:53:42 +0200

apache2 (2.4.38-3+deb10u2) buster-security; urgency=medium

  * Fix CVE-2019-10092 patch (Closes: #941202)

 -- Xavier Guimard <yadd@debian.org>  Sun, 13 Oct 2019 22:23:11 +0200

apache2 (2.4.38-3+deb10u1) buster-security; urgency=high

  * Add patch to limit cross-site scripting in mod_proxy (Closes: CVE-2019-10092)
  * Add patch to fix stack buffer overflow and NULL pointer dereference in
    mod_remoteip (Closes: CVE-2019-10097)
  * Import http2 modules from 2.4.41 (Closes: CVE-2019-9517, CVE-2019-10082 and
    CVE-2019-10081
  * Add patch to set PCRE_DOTALL by default (Closes: CVE-2019-10098)

 -- Xavier Guimard <yadd@debian.org>  Sun, 18 Aug 2019 15:34:20 +0200

apache2 (2.4.38-3) unstable; urgency=high

  [ Marc Deslauriers ]
  * SECURITY UPDATE: read-after-free on a string compare in mod_http2
    - debian/patches/CVE-2019-0196.patch: disentangelment of stream and
      request method in modules/http2/h2_request.c.
    - CVE-2019-0196
  * SECURITY UPDATE: privilege escalation from modules' scripts
    - debian/patches/CVE-2019-0211.patch: bind the bucket number of each
      child to its slot number in include/scoreboard.h,
      server/mpm/event/event.c, server/mpm/prefork/prefork.c,
      server/mpm/worker/worker.c.
    - CVE-2019-0211
  * SECURITY UPDATE: mod_ssl access control bypass
    - debian/patches/CVE-2019-0215.patch: restore SSL verify state after
      PHA failure in TLSv1.3 in modules/ssl/ssl_engine_kernel.c.
    - CVE-2019-0215
  * SECURITY UPDATE: mod_auth_digest access control bypass
    - debian/patches/CVE-2019-0217.patch: fix a race condition in
      modules/aaa/mod_auth_digest.c.
    - CVE-2019-0217
  * SECURITY UPDATE: URL normalization inconsistincy
    - debian/patches/CVE-2019-0220-1.patch: merge consecutive slashes in
      the path in include/http_core.h, include/httpd.h, server/core.c,
      server/request.c, server/util.c.
    - debian/patches/CVE-2019-0220-2.patch: fix r->parsed_uri.path safety
      in server/request.c, server/util.c.
    - debian/patches/CVE-2019-0220-3.patch: maintainer mode fix in
      server/util.c.
    - CVE-2019-0220

  [ Stefan Fritsch ]
  * Pull security fixes from 2.4.39 via Ubuntu
  * CVE-2019-0197: mod_http2: Fix possible crash on late upgrade

 -- Stefan Fritsch <sf@debian.org>  Sun, 07 Apr 2019 20:15:40 +0200

apache2 (2.4.38-2) unstable; urgency=medium

  * Disable "reset" test in allowmethods.t (Closes: #921024)

 -- Xavier Guimard <yadd@debian.org>  Thu, 31 Jan 2019 21:54:05 +0100

apache2 (2.4.38-1) unstable; urgency=medium

  [ Jelmer Vernooĳ ]
  * Reverted for now: Transition to automatic debug package (from: apache2-dbg)
  * Trim trailing whitespace
  * Use secure copyright file specification URI

  [ Niels Thykier ]
  * Add Rules-Requires-Root: binary-targets

  [ Xavier Guimard ]
  * Convert signing-key.pgp into signing-key.asc
  * Add http2.conf (Closes: #880993)
  * Remove unnecessary greater-than versioned dependency to dpkg-dev,
    libbrotli-dev and libapache2-mod-md
  * Declare compliance with policy 4.2.1
  * Add spelling errors patch (reported)
  * Fix some spelling errors in debian files


=== debian/tests/control ===
Tests: run-test-suite
Features: no-build-needed
Restrictions: allow-stderr isolation-container breaks-testbed needs-root
Depends: build-essential, apache2, apache2-dev,
         libwww-perl, libnet-ssleay-perl, libanyevent-perl, libdatetime-perl,
         libhtml-parser-perl, libtime-hires-perl, libcrypt-ssleay-perl,
         libhttp-dav-perl, libprotocol-http2-perl, libfcgi-perl,
         perl-doc

Tests: duplicate-module-load
Restrictions: allow-stderr, needs-root
Depends: apache2

Tests: htcacheclean
Restrictions: allow-stderr, needs-root, skippable
Depends: apache2

Tests: default-mods
Restrictions: allow-stderr, needs-root
Depends: apache2

Tests: ssl-passphrase
Restrictions: needs-root allow-stderr breaks-testbed
Depends: apache2, curl, expect, ssl-cert

Tests: chroot
Features: no-build-needed
Restrictions: needs-root allow-stderr breaks-testbed
Depends: apache2, wget, dpkg-dev

## apache2 2.4.40.4

=== CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Read README.cmake before using this.

PROJECT(HTTPD C)

CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

INCLUDE(CheckSymbolExists)
INCLUDE(CheckCSourceCompiles)

FIND_PACKAGE(LibXml2)
FIND_PACKAGE(Lua51)
FIND_PACKAGE(OpenSSL)
FIND_PACKAGE(ZLIB)

# Options for support libraries not supported by cmake-bundled FindFOO

# Default to using APR trunk (libapr-2.lib) if it exists in PREFIX/lib;
# otherwise, default to APR 1.x + APR-util 1.x
IF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/libapr-2.lib")
  SET(default_apr_libraries "${CMAKE_INSTALL_PREFIX}/lib/libapr-2.lib")
ELSEIF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/libapr-1.lib")
  SET(ldaplib "${CMAKE_INSTALL_PREFIX}/lib/apr_ldap-1.lib")
  IF(NOT EXISTS ${ldaplib})
    SET(ldaplib)
  ENDIF()
  SET(default_apr_libraries ${CMAKE_INSTALL_PREFIX}/lib/libapr-1.lib ${CMAKE_INSTALL_PREFIX}/lib/libaprutil-1.lib ${ldaplib})
ELSE()
  SET(default_apr_libraries)
ENDIF()

# PCRE names its libraries differently for debug vs. release builds.
# We can't query our own CMAKE_BUILD_TYPE at configure time.
# If the debug version exists in PREFIX/lib, default to that one.
IF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/pcred.lib")
  SET(default_pcre_libraries ${CMAKE_INSTALL_PREFIX}/lib/pcred.lib)
ELSE()
  SET(default_pcre_libraries ${CMAKE_INSTALL_PREFIX}/lib/pcre.lib)
ENDIF()

IF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/nghttp2d.lib")
  SET(default_nghttp2_libraries "${CMAKE_INSTALL_PREFIX}/lib/nghttp2d.lib")
ELSE()
  SET(default_nghttp2_libraries "${CMAKE_INSTALL_PREFIX}/lib/nghttp2.lib")
ENDIF()

IF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/brotlienc.lib")
  SET(default_brotli_libraries "${CMAKE_INSTALL_PREFIX}/lib/brotlienc.lib" "${CMAKE_INSTALL_PREFIX}/lib/brotlicommon.lib")
ELSE()
  SET(default_brotli_libraries)
ENDIF()

SET(APR_INCLUDE_DIR       "${CMAKE_INSTALL_PREFIX}/include" CACHE STRING "Directory with APR[-Util] include files")
SET(APR_LIBRARIES         ${default_apr_libraries}       CACHE STRING "APR libraries to link with")
SET(NGHTTP2_INCLUDE_DIR   "${CMAKE_INSTALL_PREFIX}/include" CACHE STRING "Directory with NGHTTP2 include files within nghttp2 subdirectory")
SET(NGHTTP2_LIBRARIES     ${default_nghttp2_libraries}   CACHE STRING "NGHTTP2 libraries to link with")
SET(PCRE_INCLUDE_DIR      "${CMAKE_INSTALL_PREFIX}/include" CACHE STRING "Directory with PCRE include files")
SET(PCRE_LIBRARIES        ${default_pcre_libraries}      CACHE STRING "PCRE libraries to link with")
SET(LIBXML2_ICONV_INCLUDE_DIR     ""                     CACHE STRING "Directory with iconv include files for libxml2")
SET(LIBXML2_ICONV_LIBRARIES       ""                     CACHE STRING "iconv libraries to link with for libxml2")
SET(BROTLI_INCLUDE_DIR    "${CMAKE_INSTALL_PREFIX}/include" CACHE STRING "Directory with include files for Brotli")
SET(BROTLI_LIBRARIES      ${default_brotli_libraries}    CACHE STRING "Brotli libraries to link with")
# end support library configuration

# Misc. options
OPTION(INSTALL_PDB        "Install .pdb files (if generated)"  ON)
OPTION(INSTALL_MANUAL     "Install manual"                     ON)

SET(ENABLE_MODULES        "O"                            CACHE STRING "Minimum module enablement (e.g., \"i\" to build all but those without prerequisites)")
SET(WITH_MODULES          ""                             CACHE STRING "comma-separated paths to single-file modules to statically link into the server")
SET(EXTRA_INCLUDES        ""                             CACHE STRING "Extra include directories")
SET(EXTRA_LIBS            ""                             CACHE STRING "Extra libraries")
SET(EXTRA_COMPILE_FLAGS   ""                             CACHE STRING "Extra compile flags")

IF(NOT EXISTS "${APR_INCLUDE_DIR}/apr.h")
  MESSAGE(FATAL_ERROR "APR include directory ${APR_INCLUDE_DIR} is not correct.")
ENDIF()
FOREACH(onelib ${APR_LIBRARIES})
  IF(NOT EXISTS ${onelib})
    MESSAGE(FATAL_ERROR "APR library ${onelib} was not found.")
  ENDIF()
ENDFOREACH()

MACRO(DEFINE_WITH_BLANKS output_definition input_symbol input_value)
  IF(MSVC_IDE OR ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}.${CMAKE_PATCH_VERSION} VERSION_GREATER 2.8.11)
    SET(${output_definition} "-D${input_symbol}=\"${input_value}\"")
  ELSE()
    # command-line tool + older cmake, where extra quotes must be added and
    # escaped to survive
    SET(${output_definition} "-D${input_symbol}=\"\\\"${input_value}\\\"\"")
  ENDIF()
ENDMACRO()

MACRO(GET_MOD_ENABLE_RANK macro_modname macro_mod_enable_val macro_output_rank)
  IF(${macro_mod_enable_val} STREQUAL "O")
    SET(${macro_output_rank} 0)
  ELSEIF(${macro_mod_enable_val} STREQUAL "i")
    SET(${macro_output_rank} 1)
  ELSEIF(${macro_mod_enable_val} STREQUAL "I")
    SET(${macro_output_rank} 2)
  ELSEIF(${macro_mod_enable_val} STREQUAL "a")
    SET(${macro_output_rank} 3)
  ELSEIF(${macro_mod_enable_val} STREQUAL "A")
    SET(${macro_output_rank} 4)
  ELSE()
    MESSAGE(FATAL_ERROR "Unexpected enablement value \"${macro_mod_enable_val}\" for ${macro_modname}")
  ENDIF()
ENDMACRO()

GET_MOD_ENABLE_RANK("ENABLE_MODULES setting" ${ENABLE_MODULES} enable_modules_rank)

# Figure out what APR/APU features are available
#
# CHECK_APR_FEATURE checks for features defined to 1 or 0 in apr.h or apu.h
# The symbol representing the feature will be set to TRUE or FALSE for 
# compatibility with the feature tests set by FindFooPackage.
#
# (unclear why CHECK_SYMBOL_EXISTS is needed, but I was getting "found" for anything 
# not defined to either 1 or 0)

MACRO(CHECK_APR_FEATURE which_define)
  SET(CMAKE_REQUIRED_INCLUDES "${APR_INCLUDE_DIR}")
  CHECK_SYMBOL_EXISTS(${which_define} "apr.h;apu.h" tmp_${which_define})
  IF(${tmp_${which_define}})
    CHECK_C_SOURCE_COMPILES("#include \"${APR_INCLUDE_DIR}/apr.h\"
      #include \"${APR_INCLUDE_DIR}/apu.h\"
      int main() {
      #ifndef ${which_define}
      #error gobble
      #endif
      #if !${which_define}
      #error gobble
      #endif
      return 1;}" ${which_define})
  ELSE()
    SET(${which_define})
  ENDIF()
  IF(${${which_define}})
    SET(${which_define} TRUE)
  ELSE()
    SET(${which_define} FALSE)
  ENDIF()
ENDMACRO()

CHECK_APR_FEATURE(APR_HAS_XLATE)
CHECK_APR_FEATURE(APU_HAVE_CRYPTO)

# APR_HAS_LDAP is defined in apr_ldap.h, which exists only in apr 1.x, so use
# special code instead of CHECK_APR_FEATURE()
# As with CHECK_APR_FEATURE(), convert to a TRUE/FALSE result.
CHECK_C_SOURCE_COMPILES("#include \"${APR_INCLUDE_DIR}/apr.h\"
#include \"${APR_INCLUDE_DIR}/apr_ldap.h\"
int main() {
#if !APR_HAS_LDAP
#error gobble
#endif
return 1;}" APR_HAS_LDAP)
IF(${APR_HAS_LDAP})
  SET(APR_HAS_LDAP TRUE)
ELSE()
  SET(APR_HAS_LDAP FALSE)
ENDIF()

# See if nghttp2 exists in a configured or defaulted location
SET(NGHTTP2_FOUND TRUE)
IF(EXISTS "${NGHTTP2_INCLUDE_DIR}/nghttp2/nghttp2.h")
  FOREACH(onelib ${NGHTTP2_LIBRARIES})
    IF(NOT EXISTS ${onelib})
      SET(NGHTTP2_FOUND FALSE)
    ENDIF()
  ENDFOREACH()
ELSE()
  SET(NGHTTP2_FOUND FALSE)
ENDIF()

# See if we have Brotli
SET(BROTLI_FOUND TRUE)
IF(EXISTS "${BROTLI_INCLUDE_DIR}/brotli/encode.h")
  FOREACH(onelib ${BROTLI_LIBRARIES})
    IF(NOT EXISTS ${onelib})
      SET(BROTLI_FOUND FALSE)
    ENDIF()
  ENDFOREACH()
ELSE()
  SET(BROTLI_FOUND FALSE)
ENDIF()

MESSAGE(STATUS "")
MESSAGE(STATUS "Summary of feature detection:")
MESSAGE(STATUS "")
MESSAGE(STATUS "LIBXML2_FOUND ............ : ${LIBXML2_FOUND}")
MESSAGE(STATUS "LUA51_FOUND .............. : ${LUA51_FOUND}")
MESSAGE(STATUS "NGHTTP2_FOUND ............ : ${NGHTTP2_FOUND}")
MESSAGE(STATUS "OPENSSL_FOUND ............ : ${OPENSSL_FOUND}")
MESSAGE(STATUS "ZLIB_FOUND ............... : ${ZLIB_FOUND}")
MESSAGE(STATUS "BROTLI_FOUND ............. : ${BROTLI_FOUND}")
MESSAGE(STATUS "APR_HAS_LDAP ............. : ${APR_HAS_LDAP}")
MESSAGE(STATUS "APR_HAS_XLATE ............ : ${APR_HAS_XLATE}")
MESSAGE(STATUS "APU_HAVE_CRYPTO .......... : ${APU_HAVE_CRYPTO}")
MESSAGE(STATUS "")

# Options for each available module
#   "A" ("A"ctive) means installed and active in default .conf, fail if can't be built
#   "I" ("I"nactive) means installed and inactive (LoadModule commented out) in default .conf, fail if can't be built
#   "O" ("O"mit) means not installed, no LoadModule
#   "a" - like "A", but ignore with a warning if any prereqs aren't available
#   "i" - like "I", but ignore with a warning if any prereqs aren't available

# Current heuristic for default enablement:
#
#   Module requires a prereq and           -> O
#   finding/usingprereq isn't implemented
#   yet
#
#   Module is included by default in       -> a if it has prereqs, A otherwise
#   autoconf-based build 
#
#   Module is included in                  -> i if it has prereqs, I otherwise
#   --enable-modules=most 
#
#   Otherwise                              -> O
#
SET(MODULE_LIST
  "modules/aaa/mod_access_compat+A+mod_access compatibility"
  "modules/aaa/mod_allowmethods+I+restrict allowed HTTP methods"
  "modules/aaa/mod_auth_basic+A+basic authentication"
  "modules/aaa/mod_auth_digest+I+RFC2617 Digest authentication"
  "modules/aaa/mod_auth_form+I+form authentication"
  "modules/aaa/mod_authn_anon+I+anonymous user authentication control"
  "modules/aaa/mod_authn_core+A+core authentication module"
  "modules/aaa/mod_authn_dbd+I+SQL-based authentication control"
  "modules/aaa/mod_authn_dbm+I+DBM-based authentication control"
  "modules/aaa/mod_authn_file+A+file-based authentication control"
  "modules/aaa/mod_authn_socache+I+Cached authentication control"
  "modules/aaa/mod_authnz_fcgi+I+FastCGI authorizer-based authentication and authorization"
  "modules/aaa/mod_authnz_ldap+i+LDAP based authentication"
  "modules/aaa/mod_authz_core+A+core authorization provider vector module"
  "modules/aaa/mod_authz_dbd+I+SQL based authorization and Login/Session support"
  "modules/aaa/mod_authz_dbm+I+DBM-based authorization control"
  "modules/aaa/mod_authz_groupfile+A+'require group' authorization control"
  "modules/aaa/mod_authz_host+A+host-based authorization control"
  "modules/aaa/mod_authz_owner+I+'require file-owner' authorization control"
  "modules/aaa/mod_authz_user+A+'require user' authorization control"
  "modules/arch/win32/mod_isapi+I+isapi extension support"
  "modules/cache/mod_cache+I+dynamic file caching.  At least one storage management module (e.g. mod_cache_disk) is also necessary."
  "modules/cache/mod_cache_disk+I+disk caching module"
  "modules/cache/mod_cache_socache+I+shared object caching module"
  "modules/cache/mod_file_cache+I+File cache"
  "modules/cache/mod_socache_dbm+I+dbm small object cache provider"
  "modules/cache/mod_socache_dc+O+distcache small object cache provider"
  "modules/cache/mod_socache_memcache+I+memcache small object cache provider"
  "modules/cache/mod_socache_shmcb+I+ shmcb small object cache provider"
  "modules/cluster/mod_heartbeat+I+Generates Heartbeats"
  "modules/cluster/mod_heartmonitor+I+Collects Heartbeats"
  "modules/core/mod_macro+I+Define and use macros in configuration files"
  "modules/core/mod_watchdog+I+Watchdog module"
  "modules/database/mod_dbd+I+Apache DBD Framework"
  "modules/dav/fs/mod_dav_fs+I+DAV provider for the filesystem."
  "modules/dav/lock/mod_dav_lock+I+DAV provider for generic locking"

=== debian/changelog ===
apache2 (2.4.40.4-1) unstable; urgency=medium

  * Sync Debian version:2.4.38-3+deb10u6

 -- wangyouwan <wangyouwan@uniontech.com>  Mon, 24 Jan 2022 13:42:52 +0800

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEB_BUILD_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

LSB_RELEASE := $(shell lsb_release -i -s)
BUILD_DATETIME := $(shell date -u --date="`dpkg-parsechangelog -S Date`" +%FT%T)
MODULE_DIR := /usr/lib/apache2/modules/
API := $(shell perl -ne 'print $$1 if m/define\s+MODULE_MAGIC_NUMBER_MAJOR\s+?(.*)$$/' < include/ap_mmn.h)
OPENSSL := openssl1.1
AP2_CFLAGS = -pipe $(CFLAGS)
AP2_LDFLAGS = -Wl,--as-needed $(LDFLAGS)
AP2_CPPFLAGS = -DPLATFORM='\"$(LSB_RELEASE)\"' -DBUILD_DATETIME='\"$(BUILD_DATETIME)\"' $(CPPFLAGS)
AP2_LTFLAGS = --no-silent

support/suexec-custom.c: support/suexec.c debian/patches/suexec-custom.patch
	cp support/suexec.c support/suexec-custom.c
	patch -p1 -i debian/patches/suexec-custom.patch

prebuild-checks-stamp:
	ERRS="" ;\
	for a in $$(find debian/config-dir/ -type f) ; do \
		t="$$a.$$$$" ;\
		unexpand < "$$a" > "$$t" ;\
		cmp -s "$$a" "$$t" || ERRS="$$ERRS $$a" ;\
		rm "$$t" ;\
	done ;\
	if [ -n "$$ERRS" ] ; then \
		echo 'ERROR: The following files contain spaces instead of tabs. Run through unexpand!' ;\
		ls -1 $$ERRS ;\
		false ;\
	fi
	MD5=$$(md5sum debian/index.html 2> /dev/null |cut -d' ' -f 1) ; \
	if ! grep -q $$MD5 debian/apache2.postrm ; then \
		echo "ERROR: index.html's md5 is missing in postrm!" ;\
		false ; \
	fi
	touch $@

debian/fixup_conffiles.tgz: \
    debian/config-dir/sites-available/000-default.conf \
    debian/config-dir/sites-available/default-ssl.conf \
    debian/config-dir/conf-available/charset.conf \
    debian/config-dir/conf-available/localized-error-pages.conf \
    debian/config-dir/conf-available/other-vhosts-access-log.conf \
    debian/config-dir/conf-available/security.conf \
    debian/config-dir/mods-available/cern_meta.load \
    debian/config-dir/mods-available/ident.load \
    debian/config-dir/mods-available/imagemap.load
	@# mtime/owner/group/mode are for reproducible build
	tar \
		--mtime=2000-01-01T00:00Z \
		--owner=root:0 \
		--group=root:0 \
		--mode=0644 \
		--transform 's,.*/,,' \
		-c $^ | gzip -n > $@

debian/fixup_conffiles.b64: debian/fixup_conffiles.tgz
	base64 < $< > $@

debian/apache2.preinst: debian/apache2.preinst.in debian/fixup_conffiles.b64 debian/create_preinst
	debian/create_preinst

clean-config-vars-stamp: debian/tmp/usr/share/apache2/build/config_vars.mk debian/clean_config_vars
	# Clean up config_vars.mk so that flags that are only intended for the
	# compilation of apache2 itself are not used by apxs for compiling
	# modules.
	perl ./debian/clean_config_vars '$(AP2_CFLAGS)' '$(AP2_CPPFLAGS)' '$(AP2_LDFLAGS)'
	touch $@

%: %.in
	sed 's#__SERVER_VERSION__#$(DEB_VERSION_EPOCH_UPSTREAM)#; s#__MODULE_DIR__#$(MODULE_DIR)#; s#__API__#$(API)#; s#__OPENSSL__#$(OPENSSL)#;' $< > $@
	chmod `/usr/bin/stat -c '%a' "$<"` $@

substvars-stamp: debian/rules include/ap_mmn.h
	(grep -s -v apache2:API debian/apache2-bin.substvars; echo "apache2:API=apache2-api-$(API), apache2-api-$(API)-$(OPENSSL)") > debian/apache2-bin.substvars.new
	mv debian/apache2-bin.substvars.new debian/apache2-bin.substvars
	touch $@

suexec-scripts-stamp: $(wildcard debian/debian/apache2-suexec.*.in)
	set -e ; \
	for type in custom pristine ; do \
		for f in postinst preinst prerm links dirs lintian-overrides postrm; do \
			if [ -e debian/apache2-suexec.$$f.in ] ; then \
				perl -pe "s{__TYPE__}{$$type}g" < debian/apache2-suexec.$$f.in > debian/apache2-suexec-$$type.$$f ;\
				chmod `/usr/bin/stat -c '%a' "debian/apache2-suexec.$$f.in"` debian/apache2-suexec-$$type.$$f ;\
			fi ;\
		done ;\
	done
	touch $@

clean build build-arch build-indep binary binary-arch binary-indep: %:
	dh $@ --with systemd

override_dh_auto_configure: configure-stamp
configure-stamp: prebuild-checks-stamp support/suexec-custom.c
	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) \
		--enable-layout=Debian --enable-so --with-program-name=apache2 \
		--enable-suexec --with-suexec-caller=www-data \
		--with-suexec-bin=/usr/lib/apache2/suexec --with-suexec-docroot=/var/www \
		--with-suexec-userdir=public_html --with-suexec-logfile=/var/log/apache2/suexec.log \
		--with-suexec-uidmin=100 --enable-suexec=shared --enable-log-config=static \
		--with-apr=/usr/bin/apr-1-config --with-apr-util=/usr/bin/apu-1-config \
		--with-pcre=yes \
		--enable-pie \
		--enable-mpms-shared=all \
		--enable-mods-shared="all brotli cgi ident authnz_fcgi imagemap cern_meta proxy_fdpass proxy_http2 bucketeer case_filter case_filter_in" \
		--enable-mods-static="unixd logio watchdog version" \
		CFLAGS="$(AP2_CFLAGS)" CPPFLAGS="$(AP2_CPPFLAGS)" LDFLAGS="$(AP2_LDFLAGS)" \
		LTFLAGS="$(AP2_LTFLAGS)" SHELL=/bin/bash
	touch $@

debian/config-dir/apache2.conf: debian/config-dir/apache2.conf.in
	@# Sanity check that the marker is actually there
	grep -q ___MUTEX___ $<
ifeq "$(DEB_BUILD_ARCH_OS)" "linux"
	@# On linux, we use the default pthread mutex. Comment out
	@# Mutex directive.
	perl -p -e 's,___MUTEX___,#,' < $< > $@
else
	@# On kfreebsd/hurd, pthread mutexes are not robust. There, we need to
	@# use fcntl and set the directory explicitly for multi-instance setups.
	perl -p -i -e 's,___MUTEX___,,' < $< > $@
endif

override_dh_install: clean-config-vars-stamp \
		     substvars-stamp \
		     debian/config-dir/apache2.conf \
		     debian/a2query \
		     debian/debhelper/dh_apache2 \
		     debian/apache2.preinst \
		     suexec-scripts-stamp
	# don't install mod_ssl_openssl.h in apache2-dev
	dh_install --list-missing -papache2-dev -Xopenssl
	dh_install --list-missing --remaining-packages

override_dh_fixperms-arch:
	# standard suexec
	chmod 4754 debian/apache2-suexec-pristine/usr/lib/apache2/suexec-pristine
	chgrp www-data debian/apache2-suexec-pristine/usr/lib/apache2/suexec-pristine
	# configurable suexec
	chmod 4754 debian/apache2-suexec-custom/usr/lib/apache2/suexec-custom
	chgrp www-data debian/apache2-suexec-custom/usr/lib/apache2/suexec-custom
	dh_fixperms -a -Xusr/lib/apache2/suexec-custom -Xusr/lib/apache2/suexec-pristine
	chown -R www-data:www-data debian/apache2/var/cache/apache2/mod_cache_disk
	chown root:adm debian/apache2/var/log/apache2
	chmod o-rx debian/apache2/var/log/apache2

override_dh_fixperms-indep:
	dh_fixperms -i

override_dh_installinit:
	dh_installinit --error-handler=true
	# We enable apache-htcacheclean but we don't start it, some
	# custom postinst code will then manually either disable it or
	# start the service
	dh_installinit --name apache-htcacheclean --no-start

override_dh_systemd_enable:
	dh_systemd_enable -papache2 apache2.service
	dh_systemd_enable -papache2 --name=apache2@ apache2@.service
	dh_systemd_enable -papache2 --name=apache-htcacheclean apache-htcacheclean.service
	dh_systemd_enable -papache2 --name=apache-htcacheclean@ apache-htcacheclean@.service

override_dh_installdocs-indep:
	perl debian/convert_docs debian/apache2-doc/usr/share/doc/apache2-doc/manual
	dh_installdocs -i

override_dh_installdocs-arch:
	dh_installdocs --link-doc=apache2 -papache2 -plibapache2-mod-md -plibapache2-mod-proxy-uwsgi
	dh_installdocs --link-doc=apache2-dev -papache2-ssl-dev
	dh_installdocs -a

override_dh_installchangelogs:
	# Do not install changelogs the -data package not to reduce
	# disk space usage.
	dh_installchangelogs -Napache2-data

override_dh_installman:
	mv debian/tmp/usr/share/man/man8/suexec.8 debian/tmp/usr/share/man/man8/suexec-pristine.8
	pod2man debian/debhelper/dh_apache2 > debian/manpages/dh_apache2.1
	pod2man debian/a2query.in > debian/manpages/a2query.8
	dh_installman

override_dh_strip:
	dh_strip --dbgsym-migration='apache2-dbg (<< 2.4.37-2~)'

override_dh_auto_install:
	dh_auto_install -- -j1

.PHONY: clean build build-arch build-indep binary binary-arch binary-indep

## apache2 2.4.41

=== CMakeLists.txt ===
--- 
+++ 
@@ -62,6 +62,18 @@
   SET(default_brotli_libraries "${CMAKE_INSTALL_PREFIX}/lib/brotlienc.lib" "${CMAKE_INSTALL_PREFIX}/lib/brotlicommon.lib")
 ELSE()
   SET(default_brotli_libraries)
+ENDIF()
+
+IF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/curl.lib")
+  SET(default_curl_libraries "${CMAKE_INSTALL_PREFIX}/lib/curl.lib")
+ELSE()
+  SET(default_curl_libraries)
+ENDIF()
+
+IF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/jansson.lib")
+  SET(default_jansson_libraries "${CMAKE_INSTALL_PREFIX}/lib/jansson.lib")
+ELSE()
+  SET(default_jansson_libraries)
 ENDIF()
 
 SET(APR_INCLUDE_DIR       "${CMAKE_INSTALL_PREFIX}/include" CACHE STRING "Directory with APR[-Util] include files")
@@ -74,6 +86,8 @@
 SET(LIBXML2_ICONV_LIBRARIES       ""                     CACHE STRING "iconv libraries to link with for libxml2")
 SET(BROTLI_INCLUDE_DIR    "${CMAKE_INSTALL_PREFIX}/include" CACHE STRING "Directory with include files for Brotli")
 SET(BROTLI_LIBRARIES      ${default_brotli_libraries}    CACHE STRING "Brotli libraries to link with")
+SET(CURL_LIBRARIES        "${default_curl_libraries}"    CACHE STRING "Curl libraries to link with")
+SET(JANSSON_LIBRARIES     "${default_jansson_libraries}" CACHE STRING "Jansson libraries to link with")
 # end support library configuration
 
 # Misc. options
@@ -199,6 +213,19 @@
   SET(BROTLI_FOUND FALSE)
 ENDIF()
 
+# See if we have curl
+SET(CURL_FOUND TRUE)
+IF(EXISTS "${CURL_INCLUDE_DIR}/curl/curl.h")
+  FOREACH(onelib ${CURL_LIBRARIES})
+    IF(NOT EXISTS ${onelib})
+      SET(CURL_FOUND FALSE)
+    ENDIF()
+  ENDFOREACH()
+ELSE()
+  SET(CURL_FOUND FALSE)
+ENDIF()
+
+
 MESSAGE(STATUS "")
 MESSAGE(STATUS "Summary of feature detection:")
 MESSAGE(STATUS "")
@@ -208,6 +235,8 @@
 MESSAGE(STATUS "OPENSSL_FOUND ............ : ${OPENSSL_FOUND}")
 MESSAGE(STATUS "ZLIB_FOUND ............... : ${ZLIB_FOUND}")
 MESSAGE(STATUS "BROTLI_FOUND ............. : ${BROTLI_FOUND}")
+MESSAGE(STATUS "CURL_FOUND ............... : ${CURL_FOUND}")
+MESSAGE(STATUS "JANSSON_FOUND ............ : ${JANSSON_FOUND}")
 MESSAGE(STATUS "APR_HAS_LDAP ............. : ${APR_HAS_LDAP}")
 MESSAGE(STATUS "APR_HAS_XLATE ............ : ${APR_HAS_XLATE}")
 MESSAGE(STATUS "APU_HAVE_CRYPTO .......... : ${APU_HAVE_CRYPTO}")
@@ -256,18 +285,3 @@
   "modules/aaa/mod_authz_owner+I+'require file-owner' authorization control"
   "modules/aaa/mod_authz_user+A+'require user' authorization control"
   "modules/arch/win32/mod_isapi+I+isapi extension support"
-  "modules/cache/mod_cache+I+dynamic file caching.  At least one storage management module (e.g. mod_cache_disk) is also necessary."
-  "modules/cache/mod_cache_disk+I+disk caching module"
-  "modules/cache/mod_cache_socache+I+shared object caching module"
-  "modules/cache/mod_file_cache+I+File cache"
-  "modules/cache/mod_socache_dbm+I+dbm small object cache provider"
-  "modules/cache/mod_socache_dc+O+distcache small object cache provider"
-  "modules/cache/mod_socache_memcache+I+memcache small object cache provider"
-  "modules/cache/mod_socache_shmcb+I+ shmcb small object cache provider"
-  "modules/cluster/mod_heartbeat+I+Generates Heartbeats"
-  "modules/cluster/mod_heartmonitor+I+Collects Heartbeats"
-  "modules/core/mod_macro+I+Define and use macros in configuration files"
-  "modules/core/mod_watchdog+I+Watchdog module"
-  "modules/database/mod_dbd+I+Apache DBD Framework"
-  "modules/dav/fs/mod_dav_fs+I+DAV provider for the filesystem."
-  "modules/dav/lock/mod_dav_lock+I+DAV provider for generic locking"

=== debian/changelog ===
apache2 (2.4.41-4ubuntu3.23) focal-security; urgency=medium

  * SECURITY REGRESSION: Better question mark tracking
    - debian/patches/CVE-2024-38474-regression.patch: improve
      previous patch allowing to avoid [UnsafeAllow3F] for most
      cases in modules/mappers/mod_rewrite.c (LP: #2103723).

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Wed, 02 Apr 2025 15:34:29 -0300

apache2 (2.4.41-4ubuntu3.22) focal; urgency=medium

  * d/debhelper/apache2-maintscript-helper: Allow execution when called from a
    postinst script through a trigger (i.e., postinst triggered).
    Thanks to Roel van Meer. (LP: #2038912) (Closes: #1060450)

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Mon, 18 Mar 2024 10:42:39 -0300

apache2 (2.4.41-4ubuntu3.21) focal-security; urgency=medium

  * SECURITY UPDATE: source code disclosure with handlers configured via
    AddType
    - debian/patches/CVE-2024-40725.patch: copy the trusted flag from the
      subrequest in modules/http/http_request.c.
    - CVE-2024-40725

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 17 Jul 2024 14:58:09 -0400

apache2 (2.4.41-4ubuntu3.20) focal-security; urgency=medium

  * SECURITY REGRESSION: regression when proxying http2 (LP: #2072648)
    - debian/patches/CVE-2024-38477-2.patch: restart from the original URL
      on reconnect in modules/http2/mod_proxy_http2.c.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 11 Jul 2024 10:39:23 -0400

apache2 (2.4.41-4ubuntu3.19) focal-security; urgency=medium

  * SECURITY UPDATE: null pointer dereference when serving WebSocket
    protocol upgrades over a HTTP/2
    - debian/patches/CVE-2024-36387.patch: early exit if bb is null in
      modules/http2/h2_c2.c.
    - CVE-2024-36387
  * SECURITY UPDATE: encoding problem in mod_proxy
    - debian/patches/CVE-2024-38473-1.patch: escape for non-proxypass
      configuration in modules/proxy/mod_proxy.c.
    - debian/patches/CVE-2024-38473-2.patch: fixup UDS filename for
      mod_proxy called through r->handler in modules/proxy/mod_proxy.c,
      modules/proxy/mod_proxy.h, modules/proxy/proxy_util.c.
    - debian/patches/CVE-2024-38473-3.patch: block inadvertent subst of
      special filenames in modules/mappers/mod_rewrite.c.
    - debian/patches/CVE-2024-38473-4.patch: fix comparison of local path
      on Windows in modules/mappers/mod_rewrite.c.
    - debian/patches/CVE-2024-38473-5.patch: factor out IS_SLASH, perdir
      fix in include/httpd.h, modules/mappers/mod_rewrite.c, server/util.c.
    - CVE-2024-38473
  * SECURITY UPDATE: Substitution encoding issue in mod_rewrite
    - debian/patches/CVE-2024-38474_5.patch: tighten up prefix_stat and %3f
      handling in modules/mappers/mod_rewrite.c.
    - CVE-2024-38474
  * SECURITY UPDATE: Improper escaping of output in mod_rewrite
    - Included in CVE-2024-38474_5.patch.
    - CVE-2024-38475
  * SECURITY UPDATE: information disclosure, SSRF or local script execution
    - debian/patches/CVE-2024-38476-pre1.patch: add concept of binary notes
      to request_rec in include/httpd.h.
    - debian/patches/CVE-2024-38476.patch: add ap_set_content_type_ex to
      differentiate trusted sources in include/http_protocol.h,
      include/httpd.h, modules/http/http_protocol.c,
      modules/http/mod_mime.c, modules/mappers/mod_actions.c,
      modules/mappers/mod_negotiation.c, modules/mappers/mod_rewrite.c,
      modules/metadata/mod_headers.c, modules/metadata/mod_mime_magic.c,
      server/config.c, server/core.c.
    - CVE-2024-38476
  * SECURITY UPDATE: null pointer dereference in mod_proxy
    - debian/patches/CVE-2024-38477.patch: validate hostname in
      modules/proxy/proxy_util.c.
    - CVE-2024-38477
  * SECURITY UPDATE: Potential SSRF in mod_rewrite
    - Fixed by patches in previous CVEs.
    - CVE-2024-39573
  * SECURITY UPDATE: source code disclosure with handlers configured via
    AddType
    - debian/patches/CVE-2024-39884.patch: maintain trusted flag in
      modules/cluster/mod_heartmonitor.c, modules/dav/main/mod_dav.c,
      modules/examples/mod_example_hooks.c, modules/filters/mod_data.c,
      modules/filters/mod_include.c, modules/filters/mod_proxy_html.c,
      modules/generators/mod_cgi.c, modules/generators/mod_cgid.c,
      modules/generators/mod_info.c, modules/generators/mod_status.c,
      modules/http/http_filters.c, modules/http/http_protocol.c,
      modules/http/http_request.c, modules/ldap/util_ldap.c,
      modules/mappers/mod_imagemap.c, modules/proxy/mod_proxy_balancer.c.
    - CVE-2024-39884

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 04 Jul 2024 08:31:12 -0400

apache2 (2.4.41-4ubuntu3.17) focal-security; urgency=medium

  * SECURITY UPDATE: HTTP response splitting
    - debian/patches/CVE-2023-38709.patch: header validation after
      content-* are eval'ed in modules/http/http_filters.c.
    - CVE-2023-38709
  * SECURITY UPDATE: HTTP Response Splitting in multiple modules
    - debian/patches/CVE-2024-24795.patch: let httpd handle CL/TE for
      non-http handlers in include/util_script.h,
      modules/aaa/mod_authnz_fcgi.c, modules/generators/mod_cgi.c,
      modules/generators/mod_cgid.c, modules/http/http_filters.c,
      modules/proxy/ajp_header.c, modules/proxy/mod_proxy_fcgi.c,
      modules/proxy/mod_proxy_scgi.c, modules/proxy/mod_proxy_uwsgi.c.
    - CVE-2024-24795
  * SECURITY UPDATE: HTTP/2 DoS by memory exhaustion on endless
    continuation frames
    - debian/patches/CVE-2024-27316.patch: bail after too many failed reads
      in modules/http2/h2_session.c, modules/http2/h2_stream.c,
      modules/http2/h2_stream.h.
    - CVE-2024-27316

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 10 Apr 2024 13:46:26 -0400

apache2 (2.4.41-4ubuntu3.16) focal; urgency=medium

  * d/c/m/setenvif.conf, d/p/fix-dolphin-to-delete-webdav-dirs.patch: Add
    dolphin and Konqueror/5 careful redirection so that directories can be
    deleted via webdav.
    (LP: #1927742)



=== debian/control ===
Source: apache2
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
Uploaders: Stefan Fritsch <sf@debian.org>,
           Arno Töll <arno@debian.org>,
           Ondřej Surý <ondrej@debian.org>,
           Xavier Guimard <yadd@debian.org>
Section: httpd
Priority: optional
Build-Depends: debhelper (>= 10),
               dpkg-dev (>= 1.16.1~),
               bison,
               gawk | awk,
               jdupes,
               libapr1-dev (>= 1.6.0),
               libaprutil1-dev (>= 1.6.0),
               libbrotli-dev,
               liblua5.2-dev,
               libnghttp2-dev,
               libpcre3-dev,
               libssl-dev (>= 1.1.1),
               libxml2-dev,
               lsb-release,
               perl,
               zlib1g-dev,
               libcurl4-openssl-dev | libcurl4-dev,
               libjansson-dev
Build-Conflicts: autoconf2.13
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/apache-team/apache2
Vcs-Git: https://salsa.debian.org/apache-team/apache2.git
Homepage: https://httpd.apache.org/
Rules-Requires-Root: binary-targets

Package: apache2
Architecture: any
Depends: apache2-bin (= ${binary:Version}),
         apache2-data (= ${source:Version}),
         apache2-utils (= ${binary:Version}),
         lsb-base,
         mime-support,
         ${perl:Depends},
         procps [!hurd-i386],
         ${misc:Depends}
Recommends: ssl-cert
Suggests: apache2-doc,
          apache2-suexec-pristine | apache2-suexec-custom,
          www-browser,
          ufw
Pre-Depends: dpkg (>= 1.17.14)
Breaks: libapache2-mod-proxy-uwsgi (<< 2.4.33)
Conflicts: apache2.2-bin,
           apache2.2-common
Provides: httpd,
          httpd-cgi
Replaces: apache2.2-bin,
          apache2.2-common,
          libapache2-mod-proxy-uwsgi (<< 2.4.33)
Description: Apache HTTP Server
 The Apache HTTP Server Project's goal is to build a secure, efficient and
 extensible HTTP server as standards-compliant open source software. The
 result has long been the number one web server on the Internet.
 .
 Installing this package results in a full installation, including the
 configuration files, init scripts and support scripts.

Package: apache2-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Apache HTTP Server (common files)
 The Apache HTTP Server Project's goal is to build a secure, efficient and
 extensible HTTP server as standards-compliant open source software. The
 result has long been the number one web server on the Internet.
 .
 This package contains architecture-independent common files such as icons,
 error pages and static index files.

Package: apache2-bin
Architecture: any
Depends: ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Suggests: apache2-doc,
          apache2-suexec-pristine | apache2-suexec-custom,
          www-browser
Breaks: gridsite (<< 3.0.0~20170225gitd51b2fd-1~),
        libapache2-mod-dacs (<= 1.4.38a-2),
        libapache2-mod-proxy-uwsgi (<< 2.4.33)
Provides: ${apache2:API}
Replaces: libapache2-mod-proxy-uwsgi (<< 2.4.33)
Description: Apache HTTP Server (modules and other binary files)
 The Apache HTTP Server Project's goal is to build a secure, efficient and
 extensible HTTP server as standards-compliant open source software. The
 result has long been the number one web server on the Internet.
 .
 This package contains the binaries only and does not set up a working
 web-server instance. Install the "apache2" package to get a fully working
 instance.

Package: apache2-utils
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Description: Apache HTTP Server (utility programs for web servers)
 Provides some add-on programs useful for any web server.  These include:
  - ab (Apache benchmark tool)
  - fcgistarter (Start a FastCGI program)
  - logresolve (Resolve IP addresses to hostnames in logfiles)
  - htpasswd (Manipulate basic authentication files)
  - htdigest (Manipulate digest authentication files)
  - htdbm (Manipulate basic authentication files in DBM format, using APR)
  - htcacheclean (Clean up the disk cache)
  - rotatelogs (Periodically stop writing to a logfile and open a new one)
  - split-logfile (Split a single log including multiple vhosts)
  - checkgid (Checks whether the caller can setgid to the specified group)
  - check_forensic (Extract mod_log_forensic output from Apache log files)
  - httxt2dbm (Generate dbm files for use with RewriteMap)

Package: apache2-suexec-pristine
Architecture: any
Depends: apache2-bin,
         ${misc:Depends},
         ${shlibs:Depends}
Provides: apache2-suexec
Description: Apache HTTP Server standard suexec program for mod_suexec
 Provides the standard suexec helper program for mod_suexec. This version is
 compiled with document root /var/www and userdir suffix public_html. If you
 need different settings, use the package apache2-suexec-custom.

Package: apache2-suexec-custom
Architecture: any
Depends: apache2-bin,
         ${misc:Depends},
         ${shlibs:Depends}
Provides: apache2-suexec
Description: Apache HTTP Server configurable suexec program for mod_suexec
 Provides a customizable version of the suexec helper program for mod_suexec.
 This is not the version from upstream, but can be configured with a
 configuration file.
 .
 If you do not need non-standard document root or userdir settings, it is
 recommended that you use the standard suexec helper program from the
 apache2-suexec-pristine package instead.

Package: apache2-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Recommends: apache2
Pre-Depends: ${misc:Pre-Depends}
Description: Apache HTTP Server (on-site documentation)
 The Apache HTTP Server Project's goal is to build a secure, efficient and
 extensible HTTP server as standards-compliant open source software. The
 result has long been the number one web server on the Internet.
 .
 This package provides the documentation for the Apache 2 HTTP server. The
 documentation is shipped in HTML format and can be accessed from a local
 running Apache HTTP server instance or by browsing the file system directly.

Package: apache2-dev
Architecture: any
Depends: debhelper (>= 10),
         libapr1-dev,
         libaprutil1-dev,
         openssl,
         ${misc:Depends},
         ${perl:Depends}
Provides: dh-apache2
Description: Apache HTTP Server (development headers)
 The Apache HTTP Server Project's goal is to build a secure, efficient and
 extensible HTTP server as standards-compliant open source software. The
 result has long been the number one web server on the Internet.
 .
 This package provides development headers and the apxs2 binary for the Apache
 2 HTTP server, useful to develop and link third party additions to the Debian
 Apache HTTP server package.
 .
 It also provides dh_apache2 and dh sequence addons useful to install various
 Debian Apache2 extensions with debhelper. It supports
  - Apache 2 module configurations and shared objects
  - Site configuration files
  - Global configuration files

Package: apache2-ssl-dev
Architecture: any
Depends: apache2-dev (= ${binary:Version}),
         libssl-dev (>= 1.1),
         ${misc:Depends}
Description: Apache HTTP Server (mod_ssl development headers)
 The Apache HTTP Server Project's goal is to build a secure, efficient and
 extensible HTTP server as standards-compliant open source software. The
 result has long been the number one web server on the Internet.
 .
 This package provides the development header and the dependencies for
 modules that interact with mod_ssl's internal openssl state.

Package: libapache2-mod-md
Architecture: any
Section: oldlibs
Depends: ${misc:Depends},
         apache2 (= ${binary:Version})
Description: transitional package
 This is a transitional package to apache2 for users of libapache2-mod-md.
 It can be safely removed after the installation is complete.

Package: libapache2-mod-proxy-uwsgi
Architecture: any
Section: oldlibs
Depends: ${misc:Depends},
         apache2 (= ${binary:Version})
Description: transitional package
 This is a transitional package to apache2 for users of
 libapache2-mod-proxy-uwsgi.
 It can be safely removed after the installation is complete.

=== debian/rules ===
--- 
+++ 
@@ -74,7 +74,7 @@
 	# Clean up config_vars.mk so that flags that are only intended for the
 	# compilation of apache2 itself are not used by apxs for compiling
 	# modules.
-	perl ./debian/clean_config_vars '$(AP2_CFLAGS)' '$(AP2_CPPFLAGS)' '$(AP2_LDFLAGS)'
+	perl ./debian/clean_config_vars '$(AP2_CFLAGS)' '$(AP2_CPPFLAGS)' '$(AP2_LDFLAGS)' '$(CXXFLAGS)'
 	touch $@
 
 %: %.in
@@ -103,6 +103,7 @@
 
 override_dh_auto_configure: configure-stamp
 configure-stamp: prebuild-checks-stamp support/suexec-custom.c
+	AWK=awk \
 	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) \
 		--enable-layout=Debian --enable-so --with-program-name=apache2 \
 		--enable-suexec --with-suexec-caller=www-data \
@@ -116,7 +117,7 @@
 		--enable-mods-shared="all brotli cgi ident authnz_fcgi imagemap cern_meta proxy_fdpass proxy_http2 bucketeer case_filter case_filter_in" \
 		--enable-mods-static="unixd logio watchdog version" \
 		CFLAGS="$(AP2_CFLAGS)" CPPFLAGS="$(AP2_CPPFLAGS)" LDFLAGS="$(AP2_LDFLAGS)" \
-		LTFLAGS="$(AP2_LTFLAGS)" SHELL=/bin/bash
+		LTFLAGS="$(AP2_LTFLAGS)" SHELL=/bin/bash GREP=/bin/grep
 	touch $@
 
 debian/config-dir/apache2.conf: debian/config-dir/apache2.conf.in
@@ -180,6 +181,12 @@
 	dh_installdocs --link-doc=apache2-dev -papache2-ssl-dev
 	dh_installdocs -a
 
+override_dh_link:
+	dh_link
+	if test -e debian/apache2-doc/usr/share/doc; then \
+		jdupes -rl debian/apache2-doc/usr/share/doc; \
+	fi
+
 override_dh_installchangelogs:
 	# Do not install changelogs the -data package not to reduce
 	# disk space usage.
@@ -187,14 +194,5 @@
 
 override_dh_installman:
 	mv debian/tmp/usr/share/man/man8/suexec.8 debian/tmp/usr/share/man/man8/suexec-pristine.8
+	mv debian/tmp/usr/share/man/man1/httxt2dbm.1 debian/tmp/usr/share/man/man8/httxt2dbm.8
 	pod2man debian/debhelper/dh_apache2 > debian/manpages/dh_apache2.1
-	pod2man debian/a2query.in > debian/manpages/a2query.8
-	dh_installman
-
-override_dh_strip:
-	dh_strip --dbgsym-migration='apache2-dbg (<< 2.4.37-2~)'
-
-override_dh_auto_install:
-	dh_auto_install -- -j1
-
-.PHONY: clean build build-arch build-indep binary binary-arch binary-indep

## apache2 2.4.41-4ubuntu3.8+10.0trisquel3

=== debian/changelog ===
apache2 (2.4.41-4ubuntu3.8+10.0trisquel3) nabia; urgency=medium

  * Compiled for Trisquel

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 27 Oct 2021 00:35:48 +0000

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/pkg-info.mk
 
-LSB_RELEASE := $(shell lsb_release -i -s)
+LSB_RELEASE := $(shell lsb_release -i -s)_GNU/Linux
 BUILD_DATETIME := $(shell date -u --date="`dpkg-parsechangelog -S Date`" +%FT%T)
 MODULE_DIR := /usr/lib/apache2/modules/
 API := $(shell perl -ne 'print $$1 if m/define\s+MODULE_MAGIC_NUMBER_MAJOR\s+?(.*)$$/' < include/ap_mmn.h)
